"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractMemorySettings = exports.rmFolder = void 0;
const fs = __importStar(require("fs"));
function rmFolder(p) {
    try {
        fs[process.version > 'v15' ? 'rmSync' : 'rmdirSync'](p, { recursive: true });
    }
    catch (e) { }
}
exports.rmFolder = rmFolder;
function deriveMemoryDescriptor(mem) {
    const initial = mem.buffer.byteLength / 65536;
    // test for unset maximum
    let maximum = undefined;
    try {
        mem.grow(65536 - initial);
    }
    catch (e) {
        let grows = 0;
        while (true) {
            try {
                mem.grow(1);
                grows++;
            }
            catch (e) {
                break;
            }
        }
        maximum = grows + initial;
    }
    // Note: node 14 cannot correctly spot SAB usage here!
    const shared = mem.buffer instanceof SharedArrayBuffer ? true : false;
    return { initial, maximum, shared };
}
function getExportMemoryDescriptor(def) {
    const mem = def.exports.memory;
    const descriptor = deriveMemoryDescriptor(mem);
    def.exports.memory = new WebAssembly.Memory(descriptor);
    return descriptor;
}
function getImportMemoryDescriptor(def) {
    const mem = def.imports.env.memory;
    const descriptor = deriveMemoryDescriptor(mem);
    def.imports.env.memory = new WebAssembly.Memory(descriptor);
    return descriptor;
}
function extractMemorySettings(def) {
    var _a, _b;
    if (def.exports.memory && ((_a = def.imports) === null || _a === void 0 ? void 0 : _a.env.memory)) {
        throw new Error('memory may not be exported and imported at once');
    }
    if ((_b = def.imports) === null || _b === void 0 ? void 0 : _b.env.memory) {
        const descriptor = getImportMemoryDescriptor(def);
        return { descriptor, mode: 'imported' };
    }
    if (def.exports.memory) {
        const descriptor = getExportMemoryDescriptor(def);
        return { descriptor, mode: 'exported' };
    }
    // default is exported memory as set by compiler defaults
    return {
        descriptor: undefined,
        mode: 'exported'
    };
}
exports.extractMemorySettings = extractMemorySettings;
//# sourceMappingURL=helper.js.map