"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const child_process_1 = require("child_process");
/**
 * clang specifics
 *
 * https://lld.llvm.org/WebAssembly.html
 * https://clang.llvm.org/docs/AttributeReference.html
 * https://github.com/schellingb/ClangWasm
 * https://surma.dev/things/c-to-webassembly/
 * https://github.com/jedisct1/libclang_rt.builtins-wasm32.a
 * https://depth-first.com/articles/2019/10/16/compiling-c-to-webassembly-and-running-it-without-emscripten/
 * https://aransentin.github.io/cwasm/
 *
 * __attribute__((import_module("env"), import_name("externalFunction"))) void externalFunction(void);
 * __attribute__((export_name(<name>)))
 * __attribute__((import_module(<module_name>)))
 * __attribute__((import_name(<name>)))
 */
function default_1(def, buildDir, filename, memorySettings) {
    var _a;
    // TODO: copy additional files
    process.chdir(buildDir);
    const src = `${def.name}.c`;
    const target = `${def.name}.wasm`;
    fs.writeFileSync(src, def.code);
    // TODO: apply compile options properly
    const opt = `-O3`;
    const defines = Object.entries(((_a = def.compile) === null || _a === void 0 ? void 0 : _a.defines) || {})
        .map(el => `-D${el[0]}=${el[1]}`);
    let switches = [];
    // memory settings
    if (memorySettings.descriptor) {
        if (memorySettings.descriptor.initial !== undefined) {
            switches.push(`-Wl,--initial-memory=${memorySettings.descriptor.initial * 65536}`);
        }
        if (memorySettings.descriptor.maximum !== undefined) {
            switches.push(`-Wl,--max-memory=${memorySettings.descriptor.maximum * 65536}`);
        }
    }
    if (memorySettings.mode === 'imported') {
        switches.push('-Wl,--import-memory');
    }
    // apply custom switches late
    if (def.compile && def.compile.switches) {
        switches.push(...def.compile.switches);
    }
    const ff = Object.entries(def.exports)
        .filter(el => typeof el[1] === 'function' || el[1] instanceof WebAssembly.Global)
        .map(el => `--export=${el[0]}`)
        .join(',');
    const clang = '/usr/bin/clang';
    console.log(`${clang} --target=wasm32-unknown-unknown --no-standard-libraries -Wl,${ff} -Wl,--no-entry -Wl,--lto-O3 ${opt} ${switches.join(' ')} -flto ${defines} -o ${target} ${src}`);
    const res = (0, child_process_1.spawnSync)(clang, ['--target=wasm32-unknown-unknown', '--no-standard-libraries', `-Wl,${ff}`, '-Wl,--no-entry', '-Wl,--lto-O3', opt, ...switches, '-flto', ...defines, '-o', target, src]);
    if (res.stderr)
        console.log(res.stderr.toString());
    return fs.readFileSync(target);
}
exports.default = default_1;
//# sourceMappingURL=clang_c.js.map