"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const child_process_1 = require("child_process");
function default_1(def, buildDir, filename, memorySettings) {
    var _a;
    // TODO: copy additional files
    process.chdir(buildDir);
    const src = `${def.name}.c`;
    const target = `${def.name}.wasm`;
    fs.writeFileSync(src, def.code);
    // TODO: apply compile options properly
    const opt = `-O3`;
    const defines = Object.entries(((_a = def.compile) === null || _a === void 0 ? void 0 : _a.defines) || {})
        .map(el => `-D${el[0]}=${el[1]}`);
    const _funcs = Object.entries(def.exports)
        .filter(el => typeof el[1] === 'function')
        .map(el => `_${el[0]}`)
        .join(',');
    let switches = [];
    // memory settings
    if (memorySettings.descriptor) {
        if (memorySettings.descriptor.initial !== undefined) {
            // switches.push(`-s INITIAL_MEMORY=${memorySettings.descriptor.initial * 65536}`);
        }
        if (memorySettings.descriptor.maximum !== undefined) {
            if (memorySettings.descriptor.initial !== memorySettings.descriptor.maximum) {
                switches.push(`-s MAXIMUM_MEMORY=${memorySettings.descriptor.maximum * 65536}`);
                switches.push(`-s ALLOW_MEMORY_GROWTH=1`);
            }
        }
    }
    if (memorySettings.mode === 'imported') {
        // switches.push('-s IMPORTED_MEMORY=1');
    }
    // apply custom switches late
    if (def.compile && def.compile.switches) {
        switches.push(...def.compile.switches);
    }
    // FIXME:
    //switches.push(...['-s ERROR_ON_UNDEFINED_SYMBOLS=0', '-s WARN_ON_UNDEFINED_SYMBOLS=0']);
    const funcs = ['-s', `EXPORTED_FUNCTIONS=${_funcs}`];
    const bin = '/usr/bin/emcc';
    console.log(`${bin} ${opt} ${defines} ${funcs.join(' ')} ${switches.join(' ')} --no-entry ${src} -o ${target}`);
    const res = (0, child_process_1.spawnSync)(bin, [opt, ...defines, ...funcs, ...switches, '--no-entry', src, '-o', target]);
    if (res.stderr)
        console.log(res.stderr.toString());
    return fs.readFileSync(target);
}
exports.default = default_1;
//# sourceMappingURL=emscripten_c.js.map