"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const child_process_1 = require("child_process");
const config_1 = require("../config");
const helper_1 = require("../helper");
function default_1(def, buildDir, filename, memorySettings) {
    const wd = process.cwd();
    (0, child_process_1.execSync)(`cargo version`, { shell: config_1.SHELL });
    (0, helper_1.rmFolder)(buildDir);
    process.chdir(path.dirname(buildDir));
    const src = path.join(buildDir, 'src', 'lib.rs');
    const target = path.join(buildDir, 'target', 'wasm32-unknown-unknown', 'release', `${def.name}.wasm`);
    console.log(`\n[rust.run] cargo new ${def.name} --lib`);
    (0, child_process_1.execSync)(`cargo new ${def.name} --lib`, { shell: config_1.SHELL, stdio: 'inherit' });
    process.chdir(buildDir);
    fs.writeFileSync(src, def.code);
    fs.appendFileSync('Cargo.toml', '\n[lib]\ncrate-type = ["cdylib"]\n[profile.release]\nlto = true\n');
    let switches = [];
    // memory settings
    if (memorySettings.descriptor) {
        if (memorySettings.descriptor.initial !== undefined) {
            switches.push(`-Clink-arg=--initial-memory=${memorySettings.descriptor.initial * 65536}`);
        }
        if (memorySettings.descriptor.maximum !== undefined) {
            switches.push(`-Clink-arg=--max-memory=${memorySettings.descriptor.maximum * 65536}`);
        }
    }
    if (memorySettings.mode === 'imported') {
        switches.push('-Clink-arg=--import-memory');
    }
    // apply custom switches late
    if (def.compile && def.compile.switches) {
        switches.push(...def.compile.switches);
    }
    // FIXME: make use of cargo build instead of cargo rustc?
    //execSync(`cargo build --target wasm32-unknown-unknown --release`, { shell: '/bin/bash', stdio: 'inherit' });
    const call = `cargo rustc --target wasm32-unknown-unknown --release -- ${switches.join(' ')}`;
    console.log(`\n[rust.run] ${call}`);
    (0, child_process_1.execSync)(call, { shell: config_1.SHELL, stdio: 'inherit' });
    console.log(`\n[rust.run] wasm-strip ${target}`);
    (0, child_process_1.execSync)(`${config_1.WABT_TOOL['wasm-strip']} "${target}"`, { shell: config_1.SHELL, stdio: 'inherit' });
    return fs.readFileSync(target);
}
exports.default = default_1;
//# sourceMappingURL=rust.js.map