"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const child_process_1 = require("child_process");
const zig_1 = require("../sdks/zig");
const config_1 = require("../config");
function default_1(def, buildDir, filename, memorySettings) {
    const wd = process.cwd();
    process.chdir(buildDir);
    const src = `${def.name}.zig`;
    const target = `${def.name}.wasm`;
    fs.writeFileSync(src, def.code);
    const ff = Object.entries(def.exports)
        .filter(el => typeof el[1] === 'function' || el[1] instanceof WebAssembly.Global)
        .map(el => `--export=${el[0]}`)
        .join(' ');
    let switches = [];
    // memory settings
    if (memorySettings.descriptor) {
        if (memorySettings.descriptor.initial !== undefined) {
            switches.push(`--initial-memory=${memorySettings.descriptor.initial * 65536}`);
        }
        if (memorySettings.descriptor.maximum !== undefined) {
            switches.push(`--max-memory=${memorySettings.descriptor.maximum * 65536}`);
        }
    }
    if (memorySettings.mode === 'imported') {
        switches.push('--import-memory');
    }
    // apply custom switches late
    if (def.compile && def.compile.switches) {
        switches.push(...def.compile.switches);
    }
    const call = `${(0, zig_1.getZigBinary)()} build-lib ${src} -target wasm32-freestanding -dynamic -O ReleaseFast ${ff} ${switches.join(' ')}`;
    console.log(`\n[zig.run] ${call}`);
    (0, child_process_1.execSync)(call, { shell: config_1.SHELL, stdio: 'inherit' });
    console.log(`\n[zig.run] wasm-strip ${target}`);
    (0, child_process_1.execSync)(`${config_1.WABT_TOOL['wasm-strip']} "${target}"`, { shell: config_1.SHELL, stdio: 'inherit' });
    return fs.readFileSync(target);
}
exports.default = default_1;
//# sourceMappingURL=zig.js.map