/**
 * Get the path to the emscripten SDK.
 * The call evals the config settings and may try to install
 * the SDK as stated from the config.
 */
export declare function getEmscriptenPath(): string;
/**
 * Return the bin/ path of the embedded clang version.
 */
export declare function getClangBinPath(): string;
/**
 * Run the given command in the emscripten env.
 *
 * Commands like `emcc` can be used directly (implicitly added to PATH by env script).
 * To run executables of the embedded clang version, use `getClangBinPath()` to get a
 * hold of clang's bin/ folder.
 */
export declare function emscriptenRun(cmd: string): void;
